precision mediump float;

uniform sampler2D u_Texture;
uniform sampler2D u_VanishTexture;
varying vec2 v_TexCoord;
uniform float iTime;
uniform float iZoom;
uniform float iUsePinLocation;
uniform vec2 iResolution;
uniform vec2 iPin;

float hash(in float n) {
    return fract(sin(n)*43758.5453123);
}

void main()
{
    gl_FragColor = texture2D(u_Texture, v_TexCoord);

    vec4 c0 = gl_FragColor;

    float t = pow((((1. + sin(iTime * 50.0) * .5)
         *   sin(iTime * cos(v_TexCoord.y) * 755.92653) * 0.75)
         * 3.7 + sin(iTime) * .5), 1.);

    // Separate the rgb channels to apply an individual effect
    vec4 c1 = texture2D(u_Texture, v_TexCoord+vec2(t * .02,.0));
    vec4 c2 = texture2D(u_Texture, v_TexCoord+vec2(t * -.01,.0));
    vec4 c3 = texture2D(u_Texture, v_TexCoord+vec2(t * -.025,.0));

    float noise = hash((hash(v_TexCoord.x) + v_TexCoord.y) * iTime * 10.0) * 0.2;

    gl_FragColor = vec4(vec3(c3.r, c2.g, c1.b) + noise, gl_FragColor.a + c1.a + c2.a + c3.a);
}
